﻿function GetPluginSettings()
{
	return {
		"name":			"توقّف",
		"id":			"Rex_Pause",
		"version":		"1.0",        
		"description":	"پلاگین توقّف بازی",
		"author":		"Rex.Rainbow",
		"help url":		"https://dl.dropbox.com/u/5779181/C2Repo/rex_pause.html",
		"category":		"Logic",
		"type":			"object",			// not in layout
		"rotatable":	false,
		"flags":		pf_singleglobal
	};
};

//////////////////////////////////////////////////////////////
// Conditions
AddCondition(0, cf_trigger, "لحظه‌ی توقّف", "رویداد", "لحظه‌ی توقّف", "لحظه‌ای که بازی متوقّف می‌شود", "OnPause");
AddCondition(1, cf_trigger, "لحظه‌ی ادامه‌ی بازی", "رویداد", "لحظه‌ی ادامه‌ی بازی", "لحظه‌ای که بازی از حالت توقّف خارج می‌شود", "OnResume");
AddCondition(2, 0, "آیا بازی متوقّف است", "شرط", "آیا بازی متوقّف است", "در تمام مدٖتی که بازی در حالت توقّف قرار دارد اجرا می‌شود", "IsPause");

//////////////////////////////////////////////////////////////
// Actions
AddAction(0, 0, "تغییر حالت توقّف", "توقّف/ادامه", 
          "تغییر حالت توقّف","حالت توقّف را برعکس می‌کند یعنی اگر بازی متوقّف نبود متوقّف می‌شود و برعکس", "TooglePause");  
AddComboParamOption("توقّف");
AddComboParamOption("اجرای بازی");
AddComboParam("وضعیّت", "تنظیم وضعیّت توقّف بازی",0);
AddAction(1, 0, "تعیین وضعیّت توقّف", "توقّف/ادامه", 
          "بازی به حالت {0} می‌رود", "تعیین وضعیّت توقّف", "SetState");
           

//////////////////////////////////////////////////////////////
// Expressions
AddExpression(0, ef_return_number, "Previous timescale", "Timescale", "PreTimescale", "تایم اسکال قبلی را برمی‌گرداند");



ACESDone();

// Property grid properties for this plugin
var property_list = [
	];
	
// Called by IDE when a new object type is to be created
function CreateIDEObjectType()
{
	return new IDEObjectType();
}

// Class representing an object type in the IDE
function IDEObjectType()
{
	assert2(this instanceof arguments.callee, "Constructor called as a function");
}

// Called by IDE when a new object instance of this type is to be created
IDEObjectType.prototype.CreateInstance = function(instance)
{
	return new IDEInstance(instance, this);
}

// Class representing an individual instance of an object in the IDE
function IDEInstance(instance, type)
{
	assert2(this instanceof arguments.callee, "Constructor called as a function");
	
	// Save the constructor parameters
	this.instance = instance;
	this.type = type;
	
	// Set the default property values from the property table
	this.properties = {};
	
	for (var i = 0; i < property_list.length; i++)
		this.properties[property_list[i].name] = property_list[i].initial_value;
}

// Called by the IDE after all initialization on this instance has been completed
IDEInstance.prototype.OnCreate = function()
{
}

// Called by the IDE after a property has been changed
IDEInstance.prototype.OnPropertyChanged = function(property_name)
{
}
	
// Called by the IDE to draw this instance in the editor
IDEInstance.prototype.Draw = function(renderer)
{
}

// Called by the IDE when the renderer has been released (ie. editor closed)
// All handles to renderer-created resources (fonts, textures etc) must be dropped.
// Don't worry about releasing them - the renderer will free them - just null out references.
IDEInstance.prototype.OnRendererReleased = function()
{
}
